SystemOrganization addCategory: #'Volunti-MentalBoothAuthority-Model'!
SystemOrganization addCategory: #'Volunti-MentalBoothAuthority-View'!

WATask subclass: #VOGetSecretTask
	instanceVariableNames: 'election'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Volunti-MentalBoothAuthority-View'!

VOGetSecretTask subclass: #VOAlternativeGetSecretTask
	instanceVariableNames: 'possibleSecrets'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Volunti-MentalBoothAuthority-View'!

!VOAlternativeGetSecretTask methodsFor: 'tasks' stamp: 'NicolasVanderAuwera 5/8/2012 10:26'!
alreadyVoted: user
	self call: (VOAlreadyVotedPage secret: (election tokenWithUid: user id) secretAsString)! !

!VOAlternativeGetSecretTask methodsFor: 'tasks' stamp: 'NicolasVanderAuwera 5/8/2012 13:50'!
getTokenFor: user
	^ VOAlternativeToken id: user id possibleSecrets: (self possibleSecretsFor: user id)! !

!VOAlternativeGetSecretTask methodsFor: 'running' stamp: 'NicolasVanderAuwera 8/18/2012 08:07'!
go
	| user |
	user := self identification.
	CryptographyHelper maxNumberOfBallots timesRepeat: [ self mpdvsSignatureFor: user ].
	self addAnonymousIdentity! !

!VOAlternativeGetSecretTask methodsFor: 'running' stamp: 'NicolasVanderAuwera 8/23/2012 09:54'!
mpdvsSignatureFor: user
	| share signatureAndRand token simulations |
	share := self getShareFor: user.
	token := election addToken: (self getTokenFor: user).
	signatureAndRand := election signatureOn: token secret for: user.
	simulations := election simulationOnCollection: (possibleSecrets arrayAsIntegerWithout: token secret) for: user.
	self call: (VOAlternativeTokenView token: token signature: signatureAndRand first random: signatureAndRand last).
	self call: (VOSimulatedSecretsView secrets: (possibleSecrets arrayWithout: token secret) simulations: simulations)! !

!VOAlternativeGetSecretTask methodsFor: 'accessing' stamp: 'NicolasVanderAuwera 8/23/2012 09:51'!
possibleSecretsFor: uid
	^ possibleSecrets :=  election possibleSecretsFor: uid! !

!VOGetSecretTask class methodsFor: 'instance creation' stamp: 'NicolasVanderAuwera 5/6/2012 09:24'!
for: anElection
	^ self new election: anElection! !

!VOGetSecretTask methodsFor: 'tasks' stamp: 'NicolasVanderAuwera 8/23/2012 09:54'!
addAnonymousIdentity
	| pin digipass keys |
	[ 
	pin := (self request: 'Please provide the pin code of your digipass') greaseInteger.
	(digipass := VODigipass digipassWithPin: pin) isNil ] whileTrue: [ self inform: 'Wrong pin number' ].
	keys := election requestAnonymousKeys.
	digipass anonymousSk: keys first.
	digipass anonymousPk: keys last! !

!VOGetSecretTask methodsFor: 'tasks' stamp: 'NicolasVanderAuwera 5/8/2012 10:09'!
alreadyVoted: user
	self
		inform:
			'You already have a secret linked to your id. This secret is : ' , (election tokenWithUid: user id) secret greaseString! !

!VOGetSecretTask methodsFor: 'tasks' stamp: 'NicolasVanderAuwera 5/6/2012 10:03'!
checkSignature: user
	^ election checkSignature: user! !

!VOGetSecretTask methodsFor: 'accessing' stamp: 'NicolasVanderAuwera 5/6/2012 09:23'!
election: anElection
	election := anElection! !

!VOGetSecretTask methodsFor: 'tasks' stamp: 'NicolasVanderAuwera 8/23/2012 08:16'!
getShareFor: aUser
	^ election requestSharesFor: aUser! !

!VOGetSecretTask methodsFor: 'tasks' stamp: 'NicolasVanderAuwera 5/6/2012 09:47'!
getTokenFor: user
	^ VOToken id: user id! !

!VOGetSecretTask methodsFor: 'running' stamp: 'NicolasVanderAuwera 8/23/2012 13:40'!
go
	| user |
	user := self identification.
	CryptographyHelper maxNumberOfBallots timesRepeat: [ self mpdvsSignatureFor: user ].
	self addAnonymousIdentity! !

!VOGetSecretTask methodsFor: 'tasks' stamp: 'NicolasVanderAuwera 10/28/2012 11:35'!
identification
	| checked user |
	checked := false.
	[ checked ]
		whileFalse: [ 
			user := self call: (VOUserLoginComponent user: VOMBUser new).
			(checked := self checkSignature: user)
				ifFalse: [ self inform: 'The information you provide are wrong.' ] ].
	^ user! !

!VOGetSecretTask methodsFor: 'running' stamp: 'NicolasVanderAuwera 8/23/2012 08:15'!
mpdvsSignatureFor: user
	| share signatureAndRand token |
	share := self getShareFor: user.
	token := election addToken: (self getTokenFor: user).
	signatureAndRand := election signatureOn: token secret for: user.
	self call: (VOTokenView token: token signature: signatureAndRand first random: signatureAndRand last)! !

VOAgentComponent subclass: #VOMentalBoothAuthView
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Volunti-MentalBoothAuthority-View'!

!VOMentalBoothAuthView class methodsFor: 'class initialization' stamp: 'NicolasVanderAuwera 5/5/2012 07:27'!
initialize
	super initialize.
	self register! !

!VOMentalBoothAuthView class methodsFor: 'accessing' stamp: 'NicolasVanderAuwera 12/14/2011 09:18'!
url
	^ 'mentalboothauth'! !

!VOMentalBoothAuthView methodsFor: 'accessing' stamp: 'NicolasVanderAuwera 7/23/2012 07:40'!
agentClass
	^ VOMentalBoothManager! !

!VOMentalBoothAuthView methodsFor: 'updating' stamp: 'NicolasVanderAuwera 12/30/2011 07:55'!
main
	^ VOMBMainAreaView ! !

!VOMentalBoothAuthView methodsFor: 'updating' stamp: 'NicolasVanderAuwera 8/22/2012 14:23'!
setHome
	 content := VOMBElectionsListView elections: self agent authorities! !

!VOMentalBoothAuthView methodsFor: 'accessing' stamp: 'NicolasVanderAuwera 12/14/2011 09:20'!
title
	^ 'Mental Booth Authority'! !

VOMainAreaComponent subclass: #VOMBMainAreaView
	instanceVariableNames: 'electionsListComponent'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Volunti-MentalBoothAuthority-View'!

!VOMBMainAreaView methodsFor: 'hooks' stamp: 'NicolasVanderAuwera 2/15/2012 11:09'!
children
	^ Array with: self electionsListComponent! !

!VOMBMainAreaView methodsFor: 'accessing' stamp: 'NicolasVanderAuwera 7/23/2012 07:49'!
electionsListComponent
	electionsListComponent ifNil: [ electionsListComponent := VOMBElectionsListView elections: self agent authorities ].
	^ electionsListComponent! !

!VOMBMainAreaView methodsFor: 'rendering' stamp: 'NicolasVanderAuwera 8/22/2012 13:41'!
renderMainContentOn: html
	super renderMainContentOn: html.
	html render: self electionsListComponent! !

WAComponent subclass: #VOAlreadyVotedPage
	instanceVariableNames: 'secret'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Volunti-MentalBoothAuthority-View'!

!VOAlreadyVotedPage class methodsFor: 'instance creation' stamp: 'NicolasVanderAuwera 5/8/2012 10:25'!
secret: aSecret
	^ self new secret: aSecret! !

!VOAlreadyVotedPage methodsFor: 'rendering' stamp: 'NicolasVanderAuwera 5/8/2012 10:25'!
renderContentOn: html
	self renderTitleOn: html.
	self renderSecretOn: html! !

!VOAlreadyVotedPage methodsFor: 'rendering' stamp: 'NicolasVanderAuwera 5/8/2012 10:26'!
renderSecretOn: html
	html image url: secret! !

!VOAlreadyVotedPage methodsFor: 'rendering' stamp: 'NicolasVanderAuwera 8/18/2012 08:15'!
renderTitleOn: html
	html heading
		level2;
		with: self title! !

!VOAlreadyVotedPage methodsFor: 'accessing' stamp: 'NicolasVanderAuwera 5/8/2012 10:25'!
secret: aSecret
	secret := aSecret! !

!VOAlreadyVotedPage methodsFor: 'rendering' stamp: 'NicolasVanderAuwera 8/18/2012 08:15'!
title
	^ 'You already have a secret.'! !

WAComponent subclass: #VOShowMBSecretView
	instanceVariableNames: 'identityChecker'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Volunti-MentalBoothAuthority-View'!

VOShowMBSecretView subclass: #VOShowAlternativeMBSecretView
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Volunti-MentalBoothAuthority-View'!

!VOShowAlternativeMBSecretView methodsFor: 'rendering' stamp: 'NicolasVanderAuwera 2/16/2012 10:17'!
renderAdditionalSecretsOn: html
	html paragraph: 'Memorize also these additional secrets. These secrets will be displayed during the voting phase.'
	! !

!VOShowAlternativeMBSecretView methodsFor: 'rendering' stamp: 'NicolasVanderAuwera 2/16/2012 10:15'!
renderInformationOn: html
	super renderInformationOn: html.
	self renderAdditionalSecretsOn: html! !

!VOShowAlternativeMBSecretView methodsFor: 'rendering' stamp: 'NicolasVanderAuwera 2/16/2012 10:13'!
renderSecretOn: html
	html image url: ''! !

!VOShowMBSecretView class methodsFor: 'instance creation' stamp: 'NicolasVanderAuwera 12/30/2011 07:49'!
identityChecker: anIdentityChecker
	^ self new
		identityChecker: anIdentityChecker;
		yourself! !

!VOShowMBSecretView methodsFor: 'accessing' stamp: 'NicolasVanderAuwera 12/30/2011 07:49'!
identityChecker: anIdentityChecker
	identityChecker := anIdentityChecker! !

!VOShowMBSecretView methodsFor: 'rendering' stamp: 'NicolasVanderAuwera 2/16/2012 10:14'!
renderContentOn: html
	self renderDescriptionOn: html.
	self renderInformationOn: html.
	self renderFinishOn: html! !

!VOShowMBSecretView methodsFor: 'rendering' stamp: 'NicolasVanderAuwera 2/5/2012 10:02'!
renderDescriptionOn: html
	html div
		class: 'info';
		with: [ 
					html
						paragraph:
							'A mental booth secret key has been attached to your identifier. Remember it but do not write it on any support !!' ]! !

!VOShowMBSecretView methodsFor: 'rendering' stamp: 'NicolasVanderAuwera 12/30/2011 12:02'!
renderFinishOn: html
	html anchor
		callback: [ self answer ];
		with: 'Finish'! !

!VOShowMBSecretView methodsFor: 'rendering' stamp: 'NicolasVanderAuwera 2/16/2012 10:14'!
renderInformationOn: html
	self renderUidOn: html.
	self renderSecretOn: html! !

!VOShowMBSecretView methodsFor: 'rendering' stamp: 'NicolasVanderAuwera 2/5/2012 10:03'!
renderSecretOn: html
	html div
		class: 'secret-div';
		with: [ 
					html
						paragraph: [ 
							html strong: 'Secret key: '.
							html text: identityChecker secret greaseString ] ]! !

!VOShowMBSecretView methodsFor: 'rendering' stamp: 'NicolasVanderAuwera 2/5/2012 10:04'!
renderUidOn: html
	html div
		class: 'uid-div';
		with: [ 
					html
						paragraph: [ 
							html strong: 'Identifier: '.
							html text: identityChecker uid greaseString ] ]! !

WAComponent subclass: #VOSimulatedSecretsView
	instanceVariableNames: 'secrets simulations file'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Volunti-MentalBoothAuthority-View'!

!VOSimulatedSecretsView class methodsFor: 'instance creation' stamp: 'NicolasVanderAuwera 8/23/2012 09:05'!
secrets: aCollection simulations: anotherCollection
	^ self new
		secrets: aCollection;
		simulations: anotherCollection;
		yourself! !

!VOSimulatedSecretsView methodsFor: 'rendering' stamp: 'NicolasVanderAuwera 8/23/2012 09:13'!
downloadFile
	self requestContext
		respond: [ :response | 
			response
				contentType: 'text/xml';
				document: self file rawContents greaseString;
				attachmentWithFileName: self file fileName ]! !

!VOSimulatedSecretsView methodsFor: 'accessing' stamp: 'NicolasVanderAuwera 8/23/2012 09:14'!
file
	^ file
		ifNil: [ 
			file := WAFile new
				contentType: WAMimeType textPlain;
				"contents:
						'Signature:' , (String with: Character cr) , signature greaseString , (String with: Character cr)
								, (String with: Character cr) , 'Random Number:' , (String with: Character cr) , random greaseString;" 
				fileName: 'summary' ]! !

!VOSimulatedSecretsView methodsFor: 'rendering' stamp: 'NicolasVanderAuwera 8/23/2012 09:15'!
renderContentOn: html
	self renderTitleOn: html.
	(secrets asOrderedCollection) with: simulations do: [ :secret :simulation | self renderSecret: secret simulation: simulation on: html ].
	self renderLinksOn: html! !

!VOSimulatedSecretsView methodsFor: 'rendering' stamp: 'NicolasVanderAuwera 8/23/2012 09:02'!
renderContinueOn: html
	html anchor
		class: 'button';
		callback: [ self answer ];
		with: 'Continue'! !

!VOSimulatedSecretsView methodsFor: 'rendering' stamp: 'NicolasVanderAuwera 8/23/2012 09:15'!
renderDownloadableContentOn: html
	html anchor
		callback: [ self downloadFile ];
		with: 'Download Information'! !

!VOSimulatedSecretsView methodsFor: 'rendering' stamp: 'NicolasVanderAuwera 8/23/2012 09:15'!
renderLinksOn: html
	self renderDownloadableContentOn: html.
	html text: ' and '.
	self renderContinueOn: html! !

!VOSimulatedSecretsView methodsFor: 'rendering' stamp: 'NicolasVanderAuwera 8/23/2012 09:13'!
renderSecret: secret simulation: simulation on: html
	html div: [ html image url: secret ].
	html
		div: [ 
			html
				label
				for: html nextId; with: 'Signature: '.
			html textArea
				id: html lastId;
				value: simulation first greaseString ].
	html
		div: [ 
			html
				label
				for: html nextId; with: 'Random: '.
			html textArea
				id: html lastId;
				value: simulation last greaseString ]! !

!VOSimulatedSecretsView methodsFor: 'rendering' stamp: 'NicolasVanderAuwera 8/23/2012 08:57'!
renderTitleOn: html
	html heading
		level2;
		with: self title! !

!VOSimulatedSecretsView methodsFor: 'accessing' stamp: 'NicolasVanderAuwera 8/23/2012 08:53'!
secrets: aCollection
	secrets := aCollection! !

!VOSimulatedSecretsView methodsFor: 'accessing' stamp: 'NicolasVanderAuwera 8/23/2012 08:53'!
simulations: aCollection
	simulations := aCollection! !

!VOSimulatedSecretsView methodsFor: 'accessing' stamp: 'NicolasVanderAuwera 8/23/2012 08:58'!
title
	^ 'Other secrets'! !

WAComponent subclass: #VOTokenView
	instanceVariableNames: 'token signature random file'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Volunti-MentalBoothAuthority-View'!

VOTokenView subclass: #VOAlternativeTokenView
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Volunti-MentalBoothAuthority-View'!

!VOAlternativeTokenView methodsFor: 'rendering' stamp: 'NicolasVanderAuwera 8/23/2012 08:48'!
renderDescriptionOn: html
	html div: [ html image url: token secretAsString ]! !

!VOTokenView class methodsFor: 'instance creation' stamp: 'NicolasVanderAuwera 8/23/2012 07:20'!
token: aToken signature: anInteger random: anotherInteger
	^ self new
		token: aToken;
		signature: anInteger;
		random: anotherInteger;
		yourself! !

!VOTokenView methodsFor: 'rendering' stamp: 'NicolasVanderAuwera 8/23/2012 07:42'!
downloadFile
	self requestContext
		respond: [ :response | 
			response
				contentType: 'text/xml';
				document: self file rawContents greaseString;
				attachmentWithFileName: self file fileName ]! !

!VOTokenView methodsFor: 'accessing' stamp: 'NicolasVanderAuwera 8/23/2012 07:42'!
file
	^ file
		ifNil: [ 
			file := WAFile new
				contentType: WAMimeType textPlain;
				contents:
						'Signature:' , (String with: Character cr) , signature greaseString , (String with: Character cr)
								, (String with: Character cr) , 'Random Number:' , (String with: Character cr) , random greaseString;
				fileName: 'summary' ]! !

!VOTokenView methodsFor: 'accessing' stamp: 'NicolasVanderAuwera 8/23/2012 07:20'!
random: anInteger
	random := anInteger! !

!VOTokenView methodsFor: 'rendering' stamp: 'NicolasVanderAuwera 8/23/2012 08:20'!
renderContentOn: html
	self renderTitleOn: html.
	self renderDescriptionOn: html.
	self renderLinksOn: html! !

!VOTokenView methodsFor: 'rendering' stamp: 'NicolasVanderAuwera 8/23/2012 08:19'!
renderContinueOn: html
	html anchor
		class: 'button';
		callback: [ self answer ];
		with: 'Continue'! !

!VOTokenView methodsFor: 'rendering' stamp: 'NicolasVanderAuwera 8/23/2012 07:37'!
renderDescriptionOn: html.
	html
		paragraph: [ 
			html text: 'The secret '.
			html strong: token secret greaseString.
			html text: ' is linked to your ID '.
			html strong: token id greaseString.
			html text: '. This secret must remain '.
			html strong: 'secret'.
			html text: '.' ]! !

!VOTokenView methodsFor: 'rendering' stamp: 'NicolasVanderAuwera 8/23/2012 07:40'!
renderDownloadableContentOn: html
	html anchor
		callback: [ self downloadFile ];
		with: 'Download Information'! !

!VOTokenView methodsFor: 'rendering' stamp: 'NicolasVanderAuwera 8/23/2012 08:20'!
renderLinksOn: html
	self renderDownloadableContentOn: html.
	html text: ' and '.
	self renderContinueOn: html! !

!VOTokenView methodsFor: 'rendering' stamp: 'NicolasVanderAuwera 8/23/2012 07:37'!
renderTitleOn: html
	html heading
		level2;
		with: self title! !

!VOTokenView methodsFor: 'accessing' stamp: 'NicolasVanderAuwera 8/23/2012 07:19'!
signature: anInteger
	signature := anInteger	! !

!VOTokenView methodsFor: 'accessing' stamp: 'NicolasVanderAuwera 8/23/2012 07:37'!
title
	^ 'Mental Booth Secret Key'! !

!VOTokenView methodsFor: 'accessing' stamp: 'NicolasVanderAuwera 8/23/2012 07:19'!
token: aToken
	token := aToken! !

VOAuthority subclass: #VOMentalBoothAuthority
	instanceVariableNames: 'tokens r shares'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Volunti-MentalBoothAuthority-Model'!

VOMentalBoothAuthority subclass: #VOAlternativeMentalBoothAuthority
	instanceVariableNames: 'secrets'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Volunti-MentalBoothAuthority-Model'!

VOAlternativeMentalBoothAuthority class
	instanceVariableNames: 'secrets'!

VOAlternativeMentalBoothAuthority class
	instanceVariableNames: 'secrets'!

!VOAlternativeMentalBoothAuthority class methodsFor: 'generator' stamp: 'NicolasVanderAuwera 5/8/2012 08:49'!
generateSecrets: aNumber
	| generatedSecret |
	generatedSecret := Set new.
	[ generatedSecret size = aNumber ] whileFalse: [ generatedSecret add: self secrets atRandom ].
	^ generatedSecret! !

!VOAlternativeMentalBoothAuthority class methodsFor: 'accessing' stamp: 'NicolasVanderAuwera 5/8/2012 09:14'!
secrets
	secrets := Set new.
	secrets
		add: 'http://zieglers.files.wordpress.com/2010/03/abstractvsvirtual.jpg';
		add: 'http://www.lisisoft.com/imglisi2/1/8/181570-meditation-screensaver.jpg';
		add: 'http://www.designflavr.com/images/gallery/32314160.jpg';
		add: 'http://www.bluechillies.com/graphics/screens/abstract_pictures_screensaver-40245.gif';
		add: 'http://www.youthedesigner.com/wp-content/uploads/2010/05/1-red-and-white-abstract.jpg';
		add: 'http://www.youthedesigner.com/wp-content/uploads/2010/05/2-green-flower.jpg';
		add: 'http://www.youthedesigner.com/wp-content/uploads/2010/05/4-studio-wallpaper.jpg';
		add: 'http://www.youthedesigner.com/wp-content/uploads/2010/05/5-sellcouth-wallpaper.jpg';
		add: 'http://www.youthedesigner.com/wp-content/uploads/2010/05/6-gamma.jpg';
		add: 'http://www.youthedesigner.com/wp-content/uploads/2010/05/7-ivory-onyx.jpg';
		add: 'http://www.youthedesigner.com/wp-content/uploads/2010/05/32-abstract-wallpaper.jpg';
		add: 'http://www.youthedesigner.com/wp-content/uploads/2010/05/8-insomnia-abstract.jpg';
		add: 'http://www.youthedesigner.com/wp-content/uploads/2010/05/9-rainbow-wallpaper.jpg';
		add: 'http://www.youthedesigner.com/wp-content/uploads/2010/05/10-glacialis.jpg';
		add: 'http://www.youthedesigner.com/wp-content/uploads/2010/05/11-colors-explosion.jpg';
		add: 'http://www.youthedesigner.com/wp-content/uploads/2010/05/12-solar-wallpaper.jpg';
		add: 'http://www.youthedesigner.com/wp-content/uploads/2010/05/13-abstract-wallpaper.jpg';
		add: 'http://www.youthedesigner.com/wp-content/uploads/2010/05/14-ceroxol-wallpaper.jpg';
		add: 'http://www.youthedesigner.com/wp-content/uploads/2010/05/16-green-abstract.jpg';
		add: 'http://www.youthedesigner.com/wp-content/uploads/2010/05/17-cool-abstract-wallpaper.jpg';
		add: 'http://www.youthedesigner.com/wp-content/uploads/2010/05/18-nice-abstract-wallpaper.jpg';
		add: 'http://www.youthedesigner.com/wp-content/uploads/2010/05/19-abstract-wallpaper.jpg'.
	^ secrets! !

!VOAlternativeMentalBoothAuthority methodsFor: 'initialization' stamp: 'NicolasVanderAuwera 8/20/2012 07:31'!
initialize
	super initialize.
	secrets := OrderedCollection new! !

!VOAlternativeMentalBoothAuthority methodsFor: 'testing' stamp: 'NicolasVanderAuwera 5/8/2012 08:55'!
isAlternative
	^ true! !

!VOAlternativeMentalBoothAuthority methodsFor: 'accessing' stamp: 'NicolasVanderAuwera 8/20/2012 07:24'!
possibleSecretsFor: uid
	^ secrets add: (VOSecret id: uid array: (self class generateSecrets: numberOfChoices))! !

!VOAlternativeMentalBoothAuthority methodsFor: 'accessing' stamp: 'NicolasVanderAuwera 8/23/2012 10:10'!
secretsFor: anInteger
	| s |
	s := OrderedCollection new.
	CryptographyHelper maxNumberOfBallots
		timesRepeat: [ s add: (secrets remove: (secrets detect: [ :secret | secret id = anInteger ])) ].
	^ s! !

!VOAlternativeMentalBoothAuthority methodsFor: 'mathematical functions' stamp: 'NicolasVanderAuwera 8/23/2012 08:41'!
simulationOnCollection: aCollection for: user
	^ aCollection collect: [ :element | self simulationOn: element for: user ]! !

!VOMentalBoothAuthority class methodsFor: 'defaults' stamp: 'NicolasVanderAuwera 8/3/2012 08:24'!
defaultRLength
	"256 bits"

	^ 256! !

!VOMentalBoothAuthority class methodsFor: 'generator' stamp: 'NicolasVanderAuwera 8/3/2012 08:24'!
generateRandomNumber
	^ SecureRandom new nextBits: self defaultRLength.! !

!VOMentalBoothAuthority methodsFor: 'adding' stamp: 'NicolasVanderAuwera 5/6/2012 12:46'!
addShare: aShare
	shares add: aShare! !

!VOMentalBoothAuthority methodsFor: 'adding' stamp: 'NicolasVanderAuwera 8/23/2012 08:17'!
addToken: aToken
	^ self tokens add: aToken! !

!VOMentalBoothAuthority methodsFor: 'accessing' stamp: 'NicolasVanderAuwera 5/11/2012 09:02'!
anonymousCertificate
	^ self requestAnonymousCertificate! !

!VOMentalBoothAuthority methodsFor: 'tasks' stamp: 'NicolasVanderAuwera 8/2/2012 15:32'!
checkSignature: aMBUser
	| pk |
	"pk := self anonymousCertificate tbsCertificate subjectPublicKeyInfo subjectPublicKey."
	^ true "(pk crypt: aMBUser signature) greaseString = aMBUser id greaseString"! !

!VOMentalBoothAuthority methodsFor: 'testing' stamp: 'NicolasVanderAuwera 3/1/2012 09:49'!
hasTokenWithId: anId
	^ self tokens anySatisfy: [ :token | token id = anId ]! !

!VOMentalBoothAuthority methodsFor: 'initialization' stamp: 'NicolasVanderAuwera 8/3/2012 08:24'!
initialize
	super initialize.
	opened := false.
	shares := SortedCollection new! !

!VOMentalBoothAuthority methodsFor: 'testing' stamp: 'NicolasVanderAuwera 5/8/2012 08:54'!
isAlternative
	^ false! !

!VOMentalBoothAuthority methodsFor: 'network' stamp: 'NicolasVanderAuwera 10/29/2012 16:34'!
requestAnonymousCertificate
	| ca client anonymousCertificate |
	ca := self configurations at: VOCertificationAuthority key.
	client := SocketStream openConnectionToHostNamed: ca host port: ca port.
	client
		sendCommand: #certificateOf;
		sendObject: (VOAgentX501SubjectInfo country: 'BE' organisation: 'Volunti' organisationUnit: 'Anonymous Authority').
	anonymousCertificate := client receiveObject.
	client close.
	^ anonymousCertificate! !

!VOMentalBoothAuthority methodsFor: 'network' stamp: 'NicolasVanderAuwera 8/2/2012 14:58'!
requestAnonymousKeys
	| socketStream sk pk kgs |
	kgs := self configurations at: VOKeyGenerationServer key.
	socketStream := SocketStream openConnectionToHostNamed: kgs host port: kgs port.
	socketStream sendCommand: 'keys'.
	pk := socketStream receiveObject.
	sk := socketStream receiveObject.
	socketStream close.
	^ Array with: sk with: pk! !

!VOMentalBoothAuthority methodsFor: 'network' stamp: 'NicolasVanderAuwera 8/23/2012 08:12'!
requestSharesFor: user
	| client mpdvs s |
	(self shareWithUid: user id)
		ifNil: [ 
			mpdvs := self configurations at: VOMPDVSManager key.
			client := SocketStream openConnectionToHostNamed: mpdvs host port: mpdvs port.
			client noTimeout.
			client
				sendCommand: #keygen;
				sendCommand: self id greaseString;
				sendCommand: user id greaseString.
			s := client receiveObject.
			client close.
			self assert: s size = 2.
			shares add: s second.
			user share: s first.
			^ s first ].
	^ nil! !

!VOMentalBoothAuthority methodsFor: 'searching' stamp: 'NicolasVanderAuwera 5/5/2012 15:17'!
shareWithUid: anUid
	^ shares detect: [ :share | share uid = anUid ] ifNone: [ nil ]! !

!VOMentalBoothAuthority methodsFor: 'process' stamp: 'NicolasVanderAuwera 8/23/2012 08:41'!
sign: aSecret for: uid message: msg
	| hash client witnesses partialSignature rand |
	witnesses := self configurations at: VOWitnessManager key.
	rand := self class generateRandomNumber.
	hash := CryptographyHelper hashFunction hashMessage: rand greaseString , aSecret greaseString.
	client := SocketStream openConnectionToHostNamed: witnesses host port: witnesses port.
	client
		sendCommand: msg;
		sendCommand: self id greaseString;
		sendCommand: uid greaseString;
		sendCommand: aSecret greaseString.
	partialSignature := client receiveObject.
	client close.
	^ Array with: partialSignature with: rand! !

!VOMentalBoothAuthority methodsFor: 'mathematical functions' stamp: 'NicolasVanderAuwera 5/7/2012 07:26'!
sign: m with: partialSignature for: uid
	| share partialSign |
	share := self shareWithUid: uid.
	partialSign := (share sign: m) * partialSignature \\ share n.
	^ partialSign * (share correctionFor: m) \\ share n! !

!VOMentalBoothAuthority methodsFor: 'process' stamp: 'NicolasVanderAuwera 8/23/2012 08:03'!
signatureOn: aSecret for: user
	"array stores the partial signature and the random number"

	| array |
	array := self sign: aSecret for: user id message: #signature.
	array at: 1 put: (self sign: aSecret with: array first for: user id).
	^ array! !

!VOMentalBoothAuthority methodsFor: 'process' stamp: 'NicolasVanderAuwera 8/23/2012 08:41'!
simulationOn: aSecret for: user
	"array stores the partial signature and the random number"

	| array |
	array := self sign: aSecret for: user id message: #simulation.
	array at: 1 put: (user sign: aSecret with: array first).
	^ array! !

!VOMentalBoothAuthority methodsFor: 'searching' stamp: 'NicolasVanderAuwera 5/6/2012 12:51'!
tokenWithUid: uid
	^ self tokens detect: [ :token | token id = uid ] ifNone: [ nil ]! !

!VOMentalBoothAuthority methodsFor: 'accessing' stamp: 'NicolasVanderAuwera 3/1/2012 08:10'!
tokens
	tokens ifNil: [ tokens := SortedCollection new ].
	^ tokens! !

VOElectionsListComponent subclass: #VOMBElectionsListView
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Volunti-MentalBoothAuthority-View'!

!VOMBElectionsListView methodsFor: 'rendering' stamp: 'NicolasVanderAuwera 5/8/2012 08:55'!
renderAnchorGetSecretFor: election on: html
	html anchor
		callback: [ 
					election isAlternative
						ifTrue: [ self call: (VOAlternativeGetSecretTask for: election) ]
						ifFalse: [ self call: (VOGetSecretTask for: election) ] ];
		with: 'Get Secret'! !

!VOMBElectionsListView methodsFor: 'rendering' stamp: 'NicolasVanderAuwera 2/15/2012 11:11'!
renderMoreData: election on: html
	html tableData: [ self renderAnchorGetSecretFor: election on: html ]! !

!VOMBElectionsListView methodsFor: 'rendering' stamp: 'NicolasVanderAuwera 2/15/2012 11:07'!
renderMoreDataHeadingOn: html
	html tableHeading: 'Action'! !

!VOMBElectionsListView methodsFor: 'rendering' stamp: 'NicolasVanderAuwera 5/6/2012 16:19'!
renderTableBodyOn: html
	self elections
		do: [ :election | 
			election opened
				ifFalse: [ self renderElection: election on: html ] ]! !

VOManager subclass: #VOMentalBoothManager
	instanceVariableNames: 'mentalbooths'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Volunti-MentalBoothAuthority-Model'!

!VOMentalBoothManager class methodsFor: 'x509' stamp: 'NicolasVanderAuwera 5/5/2012 13:41'!
organisationUnit
	^ 'Mental Booth Authority'! !

!VOMentalBoothManager class methodsFor: 'network' stamp: 'NicolasVanderAuwera 12/14/2011 09:19'!
port
	^ 3987! !

!VOMentalBoothManager methodsFor: 'accessing' stamp: 'NicolasVanderAuwera 8/19/2012 09:01'!
authorityClass
	^ VOMentalBoothAuthority! !

!VOMentalBoothManager methodsFor: 'accessing' stamp: 'NicolasVanderAuwera 7/23/2012 08:48'!
authorityFor: aProtocol
	aProtocol = 'mentalbooth'
		ifTrue: [ ^ VOMentalBoothAuthority ].
	aProtocol = 'alternative'
		ifTrue: [ ^ VOAlternativeMentalBoothAuthority ].
	self error: 'Unknown sub-agent.'! !

!VOMentalBoothManager methodsFor: 'network' stamp: 'NicolasVanderAuwera 7/27/2012 08:00'!
giveShareToSubAgent
	| subAgent |
	subAgent := self authorityWithId: self idOnStream! !

!VOMentalBoothManager methodsFor: 'network' stamp: 'NicolasVanderAuwera 5/8/2012 07:34'!
handle: aSymbol
	super handle: aSymbol.
	aSymbol = #tokens
		ifTrue: [ self sendTokens ].
	aSymbol = #share
		ifTrue: [ self giveShareToSubAgent ].
	aSymbol = #secrets
		ifTrue: [ self sendSecrets ]! !

!VOMentalBoothManager methodsFor: 'network' stamp: 'NicolasVanderAuwera 7/27/2012 08:00'!
sendSecrets
	| subAgent |
	subAgent := self authorityWithId: self idOnStream.
	stream sendObject: (subAgent secretsFor: stream nextLine greaseInteger).! !

!VOMentalBoothManager methodsFor: 'network' stamp: 'NicolasVanderAuwera 7/27/2012 08:00'!
sendTokens
	| id |
	id := self idOnStream.
	stream sendObject: (self authorityWithId: id) tokens! !
VOMentalBoothAuthView initialize!
